<script setup lang="ts">
import type { PropType } from 'vue'

export interface TagOption {
  type: 'next' | 'search' | 'text' | string
  isIcon: boolean
  size: 'small' | 'big' | string
  name: string
}

const props = defineProps({
  tagOption: {
    type: Object as PropType<TagOption>,
    default: () => ({})
  }
})

const emit = defineEmits<{ (event: 'update:buttonClick'): void }>()
function emitAction(event: Event) {
  emit('update:buttonClick')
}
</script>

<template>
  <template v-if="tagOption.size === 'small'">
    <button
      class="btn btn-small-style"
      type="button"
      @click="emitAction($event)"
    >
      <template v-if="!tagOption.isIcon">
        <span :class="`btn-icon-${tagOption.type}`" class="btn-content">
          {{ tagOption.name }}
        </span>
      </template>
      <template v-else>
        <span :class="`btn-only-icon-${tagOption.type}`"></span>
      </template>
    </button>
  </template>

  <template v-if="tagOption.size === 'big'">
    <button class="btn btn-big-style" type="button">
      <span :class="`btn-icon-${tagOption.type}`" class="btn-content">
        {{ tagOption.name }}
      </span>
    </button>
  </template>
</template>

<style lang="scss" scoped>
%common-button-style {
  display: flex;
  align-items: center;
  justify-content: center;
  color: #fff;
  background: #fd832c;
  border-radius: 32px;

  &:hover {
    color: #046db6;
    background-color: #fff;
    border-color: #046db6;

    .btn-icon-next::after {
      margin-left: 10px;
      content: url('@/assets/icons/arrow-light.svg');
    }

    .btn-only-icon-next::after {
      content: url('@/assets/icons/arrow-light.svg');
    }

    .btn-icon-search::after {
      display: inline-block;
      width: 16px;
      height: 16px;
      margin-left: 4px;
      content: url('@/assets/icons/search-light.svg');
    }

    .btn-only-icon-search::after {
      display: inline-block;
      width: 16px;
      height: 16px;
      content: url('@/assets/icons/search-light.svg');
    }
  }

  &:focus {
    box-shadow: unset;
  }

  &:disabled {
    color: #046db6;
    background: #efefef;

    .btn-icon-next::after {
      margin-left: 10px;
      content: url('@/assets/icons/arrow-light.svg');
    }

    .btn-only-icon-next::after {
      content: url('@/assets/icons/arrow-light.svg');
    }

    .btn-icon-search::after {
      display: inline-block;
      width: 16px;
      height: 16px;
      margin-left: 4px;
      content: url('@/assets/icons/search-light.svg');
    }

    .btn-only-icon-search::after {
      content: url('@/assets/icons/arrow-light.svg');
    }
  }

  .btn-icon-next::after {
    margin-left: 10px;
    content: url('@/assets/icons/arrow-white.svg');
  }

  .btn-only-icon-next::after {
    content: url('@/assets/icons/arrow-white.svg');
  }

  .btn-icon-search::after {
    margin-left: 4px;
    content: url('@/assets/icons/search-white.svg');
  }

  .btn-only-icon-search::after {
    content: url('@/assets/icons/search-white.svg');
  }
}
.btn-big-style {
  height: 48px;
  @extend %common-button-style;
}

.btn-small-style {
  height: 32px;
  @extend %common-button-style;
}
</style>
